package com.example.wholeestate.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.example.wholeestate.common.base.BaseController;
import com.example.wholeestate.common.resp.ResponseBean;
import com.example.wholeestate.model.PageImg;
import com.example.wholeestate.service.IPageImgService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author jobob
 * @since 2019-03-22
 */
@RestController
@RequestMapping("/")
@Api(value = "首页图片操作API", description = "首页图片操作API")
public class PageImgController extends BaseController {

    @Autowired
    private IPageImgService iPageImgService;

    @ApiOperation(value = "首页图片", notes = "首页图片")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "Query",dataType = "String",name = "id",value = "id为空时查所有" ),
    })
    @RequestMapping(value = "/pageIm", method = RequestMethod.GET)
    public ResponseBean apageImgSelect(@RequestParam(value = "id",required = false)String id) {

        ResponseBean responseBean = iPageImgService.apageImgSelect(id);
        return responseBean;
    }

    @RequestMapping(value = "/wx/banner", method = RequestMethod.GET)
    @ApiOperation(value = "微信小程序 首页Banner")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "query", dataTypeClass = String.class, name = "imgType", value = "图片类型"),
            @ApiImplicitParam(paramType = "query", dataTypeClass = String.class, name = "imgLocation", value = "图片位置")
    })
    public ResponseBean getWxBanner(@RequestParam("imgType") String imgType,
                                    @RequestParam("imgLocation") String imgLocation) {
        ResponseBean responseBean = new ResponseBean();

        QueryWrapper<PageImg> pageImgQueryWrapper = new QueryWrapper<>();
        pageImgQueryWrapper.eq("img_type", imgType);
        pageImgQueryWrapper.eq("img_location", imgLocation);
        pageImgQueryWrapper.eq("status", 1);
        List<PageImg> list = iPageImgService.list(pageImgQueryWrapper);

        responseBean.addSuccess(list);
        return responseBean;
    }

}
