package com.example.wholeestate.service.impl;


import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.example.wholeestate.common.base.BaseController;
import com.example.wholeestate.common.resp.ResponseBean;
import com.example.wholeestate.dao.BuildingDynamicMapper;
import com.example.wholeestate.dao.BuildingMapper;
import com.example.wholeestate.model.Building;
import com.example.wholeestate.model.BuildingDynamic;
import com.example.wholeestate.service.IBuildingDynamicService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;

/**
 * <p>
 * 项目动态表 服务实现类
 * </p>
 *
 * @author jobob
 * @since 2019-03-21
 */
@Service
public class BuildingDynamicServiceImpl extends ServiceImpl<BuildingDynamicMapper, BuildingDynamic> implements IBuildingDynamicService {

    @Autowired
    private BuildingDynamicMapper buildingDynamicMapper;

    @Autowired
    private BuildingMapper buildingMapper;

    @Override
    public ResponseBean iBuildingDynamicList(Integer pageNum,Integer pageSize) {
        ResponseBean response= new ResponseBean();

        Page<BuildingDynamic> page = new Page<>();
        page.setSize(pageSize == null ? 10 : pageSize);
        page.setCurrent(pageNum == null ? 1 : pageNum);
        IPage<BuildingDynamic> buildingDynamic= buildingDynamicMapper.buildingDynamicList(page);
        List<BuildingDynamic> buildingDynamicList=buildingDynamic.getRecords();

        HashMap hashMap= new HashMap<>();
        hashMap.put("list",buildingDynamicList);
        hashMap.put("total",buildingDynamic.getTotal());
        hashMap.put("pageNum",buildingDynamic.getCurrent());
        hashMap.put("pageSize",buildingDynamic.getSize());
        response.addSuccess(hashMap);
        return response;
    }

    @Override
    public ResponseBean iBuildingDynamicSelectId(Integer id) {
        ResponseBean response= new ResponseBean();
        QueryWrapper<BuildingDynamic> buildingDynamic=new QueryWrapper<>();
        buildingDynamic.lambda().eq(BuildingDynamic::getStatus,0);
        BuildingDynamic buildingDynamicList= buildingDynamicMapper.selectOne(buildingDynamic);
        response.addSuccess(buildingDynamicList);
        return response;
    }

    @Override
    public ResponseBean getWxBuildingDynamiceList(Integer pageNum, Integer pageSize) {
        ResponseBean responseBean = new ResponseBean();

        Page<BuildingDynamic> page = new Page<>();
        page.setCurrent(pageNum);
        page.setSize(pageSize);
        QueryWrapper<BuildingDynamic> buildingDynamicQueryWrapper = new QueryWrapper<>();
        buildingDynamicQueryWrapper.eq("status", "1");
        IPage<BuildingDynamic> buildingDynamicIPage = buildingDynamicMapper.selectPage(page, buildingDynamicQueryWrapper);
        List<BuildingDynamic> records = buildingDynamicIPage.getRecords();
        records.forEach(e -> {
            QueryWrapper<Building> buildingQueryWrapper = new QueryWrapper<>();
            buildingQueryWrapper.eq("building_id", e.getBuildingId());
            Building building = buildingMapper.selectOne(buildingQueryWrapper);
            e.setBuilding(building);
        });

        responseBean.addSuccess(buildingDynamicIPage);
        return responseBean;
    }

    @Override
    public ResponseBean getWxBuildingDynamiceInfo(String dynamicId) {
        ResponseBean responseBean = new ResponseBean();

        QueryWrapper<BuildingDynamic> buildingDynamicQueryWrapper = new QueryWrapper<>();
        buildingDynamicQueryWrapper.eq("dynamic_id", dynamicId);
        BuildingDynamic buildingDynamic = buildingDynamicMapper.selectOne(buildingDynamicQueryWrapper);
        responseBean.addSuccess(buildingDynamic);
        return responseBean;
    }
}
